<?php

	/**
	 * ICP Zahlungsmodul (Kopie vom icp Modul)
	 * @author Daschmi (23.10.2014)
	 */
	class wpsg_mod_icp extends wpsg_mod_basic
	{
		
		var $lizenz = 2;
		var $id = 3061;
		var $hilfeURL = 'http://wpshopgermany.de/?p=613240';
		var $currency = 'EUR';
		var $version = "4.4.9";
		var $free = true;
				
		var $api_url = array(
			'generateToken' => array(
				'live' => 'https://ctpe.net/frontend/GenerateToken',
				'test' => 'https://test.ctpe.net/frontend/GenerateToken'
			),
			'widgetjs' => array(
				'live' => 'https://ctpe.net/frontend/widget/v3/widget.js',
				'test' => 'https://test.ctpe.net/frontend/widget/v3/widget.js'
			),
			'GetStatus' => array(
				'live' => 'https://ctpe.net/frontend/GetStatus;jsessionid=',
				'test' => 'https://test.ctpe.net/frontend/GetStatus;jsessionid=',
			)
		);
		
		public function __construct()
		{
				
			parent::__construct();
				
			$this->name = __('ICP Onlinepayments', 'wpsg');
			$this->group = __('Zahlungsarten', 'wpsg');
			$this->desc = __('Ermöglicht und gewährleistet die sichere Akzeptanz von Kreditkartenzahlungen.', 'wpsg');
				
		} // public function __construct()
		
		public function install()
		{
				
			require_once(WPSG_PATH_WP.'/wp-admin/includes/upgrade.php');
				
			$sql = "CREATE TABLE ".WPSG_TBL_ORDER." (
		   		wpsg_mod_icp_ident VARCHAR(255) NOT NULL
		   	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;";
				
			dbDelta($sql);
		
			$this->shop->checkDefault('wpsg_mod_icp_sandbox', '0');
				
			$this->shop->checkDefault('wpsg_mod_icp_activ', '1');
			$this->shop->checkDefault('wpsg_mod_icp_paymenttypes', 'MASTER VISA');
			$this->shop->checkDefault('wpsg_mod_icp_name', __('ICP Onlinepayments', 'wpsg'), false, true);
			$this->shop->checkDefault('wpsg_mod_icp_hint', __('Ermöglicht und gewährleistet die sichere Akzeptanz von Kreditkartenzahlungen.', 'wpsg'), false, true);
			$this->shop->checkDefault('wpsg_mod_icp_language', 'de');
		
		} // public function install()
		
		public function settings_edit()
		{
				
			$pages = get_pages();
		
			$arPages = array(
				'-1' => __('Neu anlegen und zuordnen', 'wpsg')
			);
		
			foreach ($pages as $k => $v)
			{
				$arPages[$v->ID] = $v->post_title.' (ID:'.$v->ID.')';
			}
		
			$this->shop->view['wpsg_mod_icp']['arPages'] = $arPages;
		 	
			$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_icp/settings_edit.phtml');
				
		} // public function settings_edit()
		
		public function settings_save()
		{
		
		    $this->shop->update_option('wpsg_mod_icp_sandbox', $_REQUEST['wpsg_mod_icp_sandbox'], false, false, WPSG_SANITIZE_CHECKBOX);
		    $this->shop->update_option('wpsg_mod_icp_sender', $_REQUEST['wpsg_mod_icp_sender'], false, false, WPSG_SANITIZE_TEXTFIELD);
		    $this->shop->update_option('wpsg_mod_icp_channelid', $_REQUEST['wpsg_mod_icp_channelid'], false, false, WPSG_SANITIZE_TEXTFIELD);
		    $this->shop->update_option('wpsg_mod_icp_userid', $_REQUEST['wpsg_mod_icp_userid'], false, false, WPSG_SANITIZE_TEXTFIELD);
			$this->shop->update_option('wpsg_mod_icp_password', $_REQUEST['wpsg_mod_icp_password'], false, false, WPSG_SANITIZE_TEXTFIELD);
				
			$this->shop->update_option('wpsg_mod_icp_activ', $_REQUEST['wpsg_mod_icp_activ'], false, false, WPSG_SANITIZE_CHECKBOX);
			$this->shop->update_option('wpsg_mod_icp_paymenttypes', $_REQUEST['wpsg_mod_icp_paymenttypes'], false, false, WPSG_SANITIZE_TEXTFIELD);
			$this->shop->update_option('wpsg_mod_icp_name', $_REQUEST['wpsg_mod_icp_name'], false, false, WPSG_SANITIZE_TEXTFIELD); $this->shop->addTranslationString('wpsg_mod_icp_name', wpsg_sinput("text_field", $_REQUEST['wpsg_mod_icp_name']));
			$this->shop->update_option('wpsg_mod_icp_hint', $_REQUEST['wpsg_mod_icp_hint'], false, false, WPSG_SANITIZE_TEXTFIELD); $this->shop->addTranslationString('wpsg_mod_icp_hint', wpsg_sinput("text_field", $_REQUEST['wpsg_mod_icp_hint']));
			$this->shop->update_option('wpsg_mod_icp_logo', $_REQUEST['wpsg_mod_icp_logo'], false, false, WPSG_SANITIZE_TEXTFIELD);
			$this->shop->update_option('wpsg_mod_icp_language', $_REQUEST['wpsg_mod_icp_language'], false, false, WPSG_SANITIZE_TEXTFIELD);
			$this->shop->update_option('wpsg_mod_icp_gebuehr', $_REQUEST['wpsg_mod_icp_gebuehr'], false, false, WPSG_SANITIZE_FLOAT);
			$this->shop->update_option('wpsg_mod_icp_mwst', $_REQUEST['wpsg_mod_icp_mwst'], false, false, WPSG_SANITIZE_TAXKEY);
			$this->shop->update_option('wpsg_mod_icp_mwstland', $_REQUEST['wpsg_mod_icp_mwstland'], false, false, WPSG_SANITIZE_CHECKBOX);

			$this->shop->createPage(__('Erfolgreiche Zahlung', 'wpsg'), 'wpsg_mod_icp_successPage', wpsg_sinput(WPSG_SANITIZE_INT, $_REQUEST['wpsg_mod_icp_successPage']));
			$this->shop->createPage(__('Fehlerhafte Zahlung', 'wpsg'), 'wpsg_mod_icp_errorPage', wpsg_sinput(WPSG_SANITIZE_INT, $_REQUEST['wpsg_mod_icp_errorPage']));
				
		} // public function settings_save()

        public function wpsg_deinstall_sites() {

            wp_delete_post($this->shop->get_option('wpsg_mod_icp_successPage'));
            wp_delete_post($this->shop->get_option('wpsg_mod_icp_errorPage'));

        } // public function wpsg_deinstall_sites()

		public function addPayment(&$arPayment) {
		
			if (is_admin() || $this->shop->get_option('wpsg_mod_icp_activ') == '1') {
		
				$arPayment[$this->id] = array(
					'id' => $this->id,
					'name' => __($this->shop->get_option('wpsg_mod_icp_name'), 'wpsg'),
					'price' => $this->shop->get_option('wpsg_mod_icp_gebuehr'),
					'tax_key' => $this->shop->get_option('wpsg_mod_icp_mwst'),
					'mwst_null' => $this->shop->get_option('wpsg_mod_icp_mwstland'),
					'hint' => __($this->shop->get_option('wpsg_mod_icp_hint'), 'wpsg'),
					'logo' => ((wpsg_isSizedString($this->shop->get_option('wpsg_mod_icp_logo')))?$this->shop->get_option('wpsg_mod_icp_logo'):$this->shop->getRessourceURL('mods/mod_icp/gfx/logo_100x25.png'))
				);
		
			}
				
		} // public function addPayment(&$arPayment)
		 
		public function order_done(&$order_id, &$done_view)
		{
		
			global $q_config;
			
			// Bestellungen mit 0 geben nix aus
			if ($done_view['basket']['sum']['preis_gesamt_brutto'] <= 0) return;
				
			if ($this->id == $this->shop->view['basket']['checkout']['payment'])
			{
					
				// Ident Request
				$ident = $this->getIdent($order_id);
		
				if ($ident !== false)
				{
						
					$this->shop->view['wpsg_mod_icp']['ident'] = $ident;
					$this->shop->view['wpsg_mod_icp']['statusURL'] = $this->getStatusUrl();
		
					$widgetURL = $this->api_url['widgetjs']['live'];
					if ($this->shop->get_option('wpsg_mod_icp_sandbox') === '1') $widgetURL = $this->api_url['widgetjs']['test'];
						
					$set_lang = $this->shop->get_option('wpsg_mod_icp_language');
					if ($set_lang === 'auto')
					{
		
						$arLocales = $q_config['locale'];
		
						if (wpsg_isSizedArray($arLocales) && wpsg_isSizedString(get_locale()) && in_array(get_locale(), $arLocales))
						{
		
							$set_lang = array_search(get_locale(), $arLocales);
		
						}
						else
						{
		
							// Wenn Mehrsprachigkeit nicht korrekt konfiguriert oder ISO Code nicht ermittelt werden konnte
							// auf die schöne gute alte deutsche Sprache zurückgreifen
							$set_lang = "de";
		
						}
		
					}
						
					$set_lang = strtolower($set_lang);
					if (!in_array($set_lang, array('de', 'en'))) $set_lang = 'de';
						
					$widgetURL .= '?style=card&language='.$set_lang;
						
					$this->shop->view['wpsg_mod_icp']['paymenttypes'] = $this->shop->get_option('wpsg_mod_icp_paymenttypes');
					$this->shop->view['wpsg_mod_icp']['widgetjs'] = $widgetURL;
		
				}
				else
				{
						
					$log = array();
					$log[] = "Token konnte nicht gebildet werden.";
					$log[] = "\r\nCURL Error: ".$this->shop->last_curl_error;
						
					$log = implode("\r\n", $log);
					 
					// Eintrag im Bestellprotokoll
					$this->db->ImportQuery(WPSG_TBL_OL, array(
							"title" => __("ICP Fehler", "wpsg"),
							"cdate" => "NOW()",
							"o_id" => wpsg_q($order_id),
							"mailtext" => wpsg_q($log_txt)
					));
		
					$this->shop->view['wpsg_mod_icp']['ident'] = false;
						
				}
		
				$this->shop->render(WPSG_PATH_VIEW.'/mods/mod_icp/order_done.phtml');
					
			}
				
		} // public function order_done(&$order_id, &$done_view)
			
		public function template_redirect()
		{
		
			if ($_REQUEST['wpsg_plugin'] != 'wpsg_mod_icp') return;
				
			if ($_REQUEST['wpsg_action'] === 'checkStatus')
			{
		
				$arParam = array();
		
				$url = $this->api_url['GetStatus']['live'];
				if ($this->shop->get_option('wpsg_mod_icp_sandbox') === '1') $url = $this->api_url['GetStatus']['test'];
		
				$url .= $_REQUEST['token'];
		
				$result = $this->shop->get_url_post_content($url, $arParam);
				$resultJson = json_decode($result, true);
		
				if (	strstr($resultJson['transaction']['processing']['result'], "ACK") &&
				wpsg_isSizedInt($resultJson['transaction']['identification']['shopperid']) &&
				wpsg_isSizedString($resultJson['transaction']['payment']['clearing']['amount'])
				)
				{
						
					$order_id = $resultJson['transaction']['identification']['shopperid'];
					$payed_amount = wpsg_tf($resultJson['transaction']['payment']['clearing']['amount']);
						
					$log = print_r($resultJson, 1);
						
					$this->db->ImportQuery(WPSG_TBL_OL, array(
							"title" => __("ICP Zahlung erfolgt", "wpsg"),
							"cdate" => "NOW()",
							"o_id" => wpsg_q($order_id),
							"mailtext" => wpsg_q($log)
					));
		
					if ($this->shop->setPayMent($order_id, $payed_amount))
					{
							
						$this->shop->setOrderStatus($order_id, 100, true);
		
						// Zahlung erfolgreich
						$this->shop->redirect(get_permalink($this->shop->get_option('wpsg_mod_icp_successPage')));
		
					}
					else
					{
		
						// Zahlung fehlgeschlagen / Betrag war nicht korrekt
						$this->shop->redirect(get_permalink($this->shop->get_option('wpsg_mod_icp_errorPage')));
		
					}
						
				}
				else
				{
		
					// Zahlung fehlgeschlagen
					$this->shop->redirect(get_permalink($this->shop->get_option('wpsg_mod_icp_errorPage')));
						
				}
		
			}
		
		} // public function template_redirect()
		
		public function mail_payment()
		{
		
			if ($this->id != $this->shop->view['basket']['checkout']['payment']) return;
		
			if ($this->shop->htmlMail === true)
			{
		
				echo '<a href="'.$this->shop->getDoneURL($this->shop->view['o_id']).'">'.__('Zahlungslink', 'wpsg').'</a>'.__(', um die Zahlung durchzuführen', 'wpsg');
		
			}
			else
			{
					
				echo wpsg_pad_right(__('Zahlungslink', 'wpsg').':', 35).$this->shop->getDoneURL($this->shop->view['o_id']);
		
			}
		
		} // public function mail_payment()
		
		/* Modulfunktionen */
		
		/**
		 * URL für die Statusabfrage
		 */
		public function getStatusUrl()
		{
				
			$basket_link = get_permalink($this->shop->get_option('wpsg_page_basket'));
		
			if (strpos($basket_link, "?") > 0)
			{
				$basket_link .= "&wpsg_plugin=wpsg_mod_icp&wpsg_action=checkStatus";
			}
			else
			{
				$basket_link .= "?wpsg_plugin=wpsg_mod_icp&wpsg_action=checkStatus";
			}
				
			return $basket_link;
				
		} // public function getStatusUrl()
		
		/**
		 * Initiiert den Zahlungsprozess und gibt die Ident zurück und speichert sie in der Bestellung
		 */
		public function getIdent($order_id)
		{
				
			$oOrder = $this->shop->cache->loadOrderObject($order_id);
				
			$arParam = array(
				'SECURITY.SENDER' => $this->shop->get_option('wpsg_mod_icp_sender'),
				'TRANSACTION.CHANNEL' => $this->shop->get_option('wpsg_mod_icp_channelid'),
				'TRANSACTION.MODE' => 'LIVE',
				'IDENTIFICATION.SHOPPERID' => $order_id,
				'USER.LOGIN' => $this->shop->get_option('wpsg_mod_icp_userid'),
				'USER.PWD' => $this->shop->get_option('wpsg_mod_icp_password'),
				'PAYMENT.TYPE' => 'DB',
				'PRESENTATION.AMOUNT' => $oOrder->getAmount(),
				'PRESENTATION.CURRENCY' => 'EUR'
			);
				
			if ($this->shop->get_option('wpsg_mod_icp_sandbox') === '1') $arParam['TRANSACTION.MODE'] = 'CONNECTOR_TEST';
				
			$url = $this->api_url['generateToken']['live'];
			if ($this->shop->get_option('wpsg_mod_icp_sandbox') === '1') $url = $this->api_url['generateToken']['test'];
		
			$result = $this->shop->get_url_post_content($url, $arParam);
			$ident = json_decode($result);
				
			$token = $ident->transaction->token;
				
			if (strpos($result, 'Erorr') !== false || !is_object($ident) || !wpsg_isSizedString($token))
			{
		
				return false;
		
			}
			else
			{
		
				$oOrder->wpsg_mod_icp_ident = $token;
				$oOrder->save();
		
				return $token;
		
			}
				
		} // public function getIdent($order_id)
				
	} // class wpsg_mod_icp extends wpsg_mod_icp

?>